searchNodes=[{"doc":"A bucket-based rate limit algorithm with support for clusters. Usage Create a module that acts as the rate limiter: defmodule MyApiRateLimit do use BucketHydra, pubsub: MyAppWeb.Endpoint, size: 50, time_scale: :timer.minutes(5) end Start your rate limiter in each node of the cluster: children = [ # ... MyApiRateLimit, # ... ] Consume space in a bucket with consume/2, for instance in a plug that guards your API: def call(conn, opts) do # ... if MyApiRateLimit.consume(conn.assigns.api_key) do conn else conn |&gt; send_resp(429, &quot;Rate limit exceeded&quot;) |&gt; halt() end end Clustering BucketHydra was specifically built to act as a rate limiter in a multi- node cluster. It syncronizes the usages across all instances of itself using Phoenix.PubSub broadcasts. If you&#39;re not using phoenix, you can still use the phoenix_pubsub library and simply start a pubsub (a good starting point is Phoenix.PubSub.PG2) instance in your application supervisor. Caveats When a bucket only has one space left and 2 requests for the same bucket arrive at the same time, both might be allowed to happen. In cases of a net split, the resulting clusters will work on their own and might allow more incoming requests in total. After the net split heals, all nodes are synchronized again.","ref":"BucketHydra.html","title":"BucketHydra","type":"behaviour"},{"doc":"Generated record functions to interact with buckets returned by get_bucket/2.","ref":"BucketHydra.html#bucket/1","title":"BucketHydra.bucket/1","type":"macro"},{"doc":"","ref":"BucketHydra.html#bucket/2","title":"BucketHydra.bucket/2","type":"macro"},{"doc":"Checks if the bucket for the given key still has enough space without consuming that space.","ref":"BucketHydra.html#c:can_consume?/2","title":"BucketHydra.can_consume?/2","type":"callback"},{"doc":"Checks if the bucket for the given key still has enough space, and then consumes that space. Returns true if there was space left and consumed.","ref":"BucketHydra.html#c:consume/2","title":"BucketHydra.consume/2","type":"callback"},{"doc":"","ref":"BucketHydra.html#consumption/2","title":"BucketHydra.consumption/2","type":"macro"},{"doc":"Consumes space in the bucket without checking for capacity","ref":"BucketHydra.html#c:do_consume/2","title":"BucketHydra.do_consume/2","type":"callback"},{"doc":"Gets the bucket for the given key, time_scale and time (via bucket_opts).","ref":"BucketHydra.html#c:get_bucket/2","title":"BucketHydra.get_bucket/2","type":"callback"},{"doc":"","ref":"BucketHydra.html#key/2","title":"BucketHydra.key/2","type":"macro"},{"doc":"Calculates the time bucket for the given scale that a request for the given time would fall into.","ref":"BucketHydra.html#c:time_bucket/2","title":"BucketHydra.time_bucket/2","type":"callback"},{"doc":"","ref":"BucketHydra.html#t:bucket/0","title":"BucketHydra.bucket/0","type":"type"},{"doc":":size a positive integer of how big the bucket is, default 120 :time_scale a positive integer in milliseconds how long a bucket lasts until it is emptied, default 60_000 ms :cost if consuming from a bucket should cost more than 1 use, specify the increased cost here, default 1 :for_time default System.system_time(:millisecond) - a different time (in milliseconds) can be passed so a request might fall into an older or newer bucket.","ref":"BucketHydra.html#t:bucket_opt/0","title":"BucketHydra.bucket_opt/0","type":"type"},{"doc":"","ref":"BucketHydra.html#t:bucket_opts/0","title":"BucketHydra.bucket_opts/0","type":"type"},{"doc":"","ref":"BucketHydra.html#t:consumption/0","title":"BucketHydra.consumption/0","type":"type"},{"doc":"The key for a bucket can be anything but we recommend using primitive IDs such as UUIDs, integers or atoms.","ref":"BucketHydra.html#t:key/0","title":"BucketHydra.key/0","type":"type"},{"doc":"","ref":"BucketHydra.html#t:key_record/0","title":"BucketHydra.key_record/0","type":"type"}]